Bug 247473 - Akregator adds articles to the bottom of the list instead of the top
Summary: Akregator adds articles to the bottom of the list instead of the top
Status: RESOLVED FIXED
Alias: None
Product: akregator
Classification: Unclassified
Component: general (show other bugs)
Version: 1.6.5
Platform: Unlisted Binaries Linux
: NOR normal with 86 votes (vote)
Target Milestone: ---
Assignee: kdepim bugs
URL:
Keywords:
: 247481 248872 251708 253333 254062 257316 262872 274870 277083 277353 283791 287648 289595 (view as bug list)
Depends on:
Blocks:
 
Reported: 2010-08-12 09:04 UTC by Halla Rempt
Modified: 2014-03-16 20:46 UTC (History)
23 users (show)

See Also:
Latest Commit:
Version Fixed In: 4.8


Attachments
Screenshot (216.63 KB, image/png)
2014-03-16 20:22 UTC, Philip Murray
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Halla Rempt 2010-08-12 09:04:59 UTC
Version:           1.6.5
OS:                Linux

On downloading a new feed, for some feeds like planet.gnome.org, Akregator adds all new articles to the bottom of the list, though I have the articles sorted by date, showing newest first, and the dates of those artices are correct. This did not happen with the previous version I used.

Reproducible: Didn't try




OS: Linux (i686) release 2.6.34-12-default
Compiler: gcc
Comment 1 Christophe Giboudeaux 2010-08-29 10:38:28 UTC
*** Bug 248872 has been marked as a duplicate of this bug. ***
Comment 2 Christophe Giboudeaux 2010-08-29 10:45:12 UTC
*** Bug 247481 has been marked as a duplicate of this bug. ***
Comment 3 Andrey Rahmatullin 2010-08-29 14:57:03 UTC
Note that 248872/247481 contain more details about this bug.
Comment 4 Christophe Giboudeaux 2010-09-24 02:50:00 UTC
*** Bug 251708 has been marked as a duplicate of this bug. ***
Comment 5 Alex Merry 2010-10-02 19:04:41 UTC
I'm running akregator from trunk, and this has just recently started happening for me.

The issue seems to be that the various QSortFilterProxyModels are not told to re-sort when a new article is added.  Making the SortColorizeProxyModel dynamic doesn't seem to fix the issue, though.
Comment 6 Christophe Giboudeaux 2010-10-13 15:15:17 UTC
*** Bug 254062 has been marked as a duplicate of this bug. ***
Comment 7 H.H. 2010-10-13 15:42:43 UTC
I am quite sure, that this bug has to do with linking against qt-4.7. Because it happens not for a kde-4.5 build against qt-4.6.3 for me.
Comment 8 turtle 2010-10-13 16:39:17 UTC
This bug affects to me in KUbuntu Maverick
Comment 9 Halla Rempt 2010-11-30 09:49:49 UTC
I'm also using Qt 4.7
Comment 10 Jure Repinc 2010-12-19 23:09:04 UTC
Ordering also becomes broken if you Fir have Akregator to show only Unread articles, then you read them all and switch the view to All Articles.
Comment 11 stu 2011-01-16 13:16:50 UTC
*** Bug 262872 has been marked as a duplicate of this bug. ***
Comment 12 Christophe Giboudeaux 2011-01-24 12:07:21 UTC
*** Bug 253333 has been marked as a duplicate of this bug. ***
Comment 13 H.H. 2011-01-27 00:32:04 UTC
this is really bad, because kde-4.6 now ships with qt 4.7
Comment 14 stu 2011-04-06 19:18:42 UTC
Is this still broken?
Comment 15 Halla Rempt 2011-04-06 19:21:11 UTC
With version 1.6.6, yes.
Comment 16 H.H. 2011-04-06 20:46:29 UTC
it is still broken with kde-4.6.1
Comment 17 Jaka Kranjc 2011-04-11 17:03:38 UTC
KDE 4.6.2/QT 4.7 too.
Comment 18 Alex Merry 2011-04-11 23:10:00 UTC
Git commit a70973b91b6dd2b14462a114ce2c0b520e41b3af by Alex Merry.
Committed on 11/04/2011 at 23:09.
Pushed by alexmerry into branch '4.4'.

Maintain sort order when new articles are added

Backport of e95e0f8e3687137f02e19d3ecf5ea0a9463f5962

In Qt 4.7, QSortFilterProxyModels no longer maintain their sort order
unless explicitly told to.  This meant that new articles would always
end up at the bottom of the list being displayed, even if the list was
sorted newest-first.

Incidentally, I could have sworn I tried this fix already and it didn't
work.

CCBUG: 247473
FIXED-IN: 4.4.11

M  +3    -0    akregator/src/articlelistview.cpp     

http://commits.kde.org/kdepim/a70973b91b6dd2b14462a114ce2c0b520e41b3af
Comment 19 Alex Merry 2011-04-11 23:10:00 UTC
Git commit e95e0f8e3687137f02e19d3ecf5ea0a9463f5962 by Alex Merry.
Committed on 11/04/2011 at 23:09.
Pushed by alexmerry into branch 'master'.

Maintain sort order when new articles are added

In Qt 4.7, QSortFilterProxyModels no longer maintain their sort order
unless explicitly told to.  This meant that new articles would always
end up at the bottom of the list being displayed, even if the list was
sorted newest-first.

Incidentally, I could have sworn I tried this fix already and it didn't
work.

BUG: 247473
FIXED-IN: 4.6.0

M  +3    -0    akregator/src/articlelistview.cpp     

http://commits.kde.org/kdepim/e95e0f8e3687137f02e19d3ecf5ea0a9463f5962
Comment 20 Christophe Giboudeaux 2011-04-29 19:55:57 UTC
reopen, the commit had to be reverted due to serious regressions
Comment 21 Ralf Jung 2011-06-04 15:07:12 UTC
Bug 257316 looks like a duplicate of this one to me, but I am not sure.
Comment 22 Christophe Giboudeaux 2011-06-06 17:42:57 UTC
*** Bug 257316 has been marked as a duplicate of this bug. ***
Comment 23 Christophe Giboudeaux 2011-06-16 15:13:19 UTC
*** Bug 274870 has been marked as a duplicate of this bug. ***
Comment 24 Christophe Giboudeaux 2011-07-08 08:33:24 UTC
*** Bug 277083 has been marked as a duplicate of this bug. ***
Comment 25 Christophe Giboudeaux 2011-07-08 10:28:18 UTC
*** Bug 277353 has been marked as a duplicate of this bug. ***
Comment 26 Andrew Munkres 2011-07-16 05:24:23 UTC
What "serious regressions"? It was working fine for me in kdepim version 4.4.11.

The only regression I've seen is that bug 247473 is back now in kdepim 4.6.1 because the patch was reverted...
Comment 27 Christophe Giboudeaux 2011-07-16 08:51:45 UTC
(In reply to comment #26)
> What "serious regressions"? It was working fine for me in kdepim version
> 4.4.11.
> 
> The only regression I've seen is that bug 247473 is back now in kdepim 4.6.1
> because the patch was reverted...

https://bugs.kde.org/show_bug.cgi?id=271640 is the regression
Comment 28 H.H. 2011-07-31 10:52:19 UTC
I would be very glad if this bug would be fixed soon. I am vey disappointed, that it worked again for some time, and now in kde-4.7 not anymore :(
Comment 29 Ralf Jung 2011-10-06 08:37:26 UTC
The problem is still present both in KDE 4.7 and in the current git version.
Comment 30 Christophe Giboudeaux 2011-10-13 10:26:41 UTC
*** Bug 283791 has been marked as a duplicate of this bug. ***
Comment 31 Christophe Giboudeaux 2011-11-27 09:46:58 UTC
*** Bug 287648 has been marked as a duplicate of this bug. ***
Comment 32 Christophe Giboudeaux 2011-12-22 23:01:42 UTC
*** Bug 289595 has been marked as a duplicate of this bug. ***
Comment 33 H.H. 2012-01-08 11:53:17 UTC
after hours of try&error I have a patch working (which does not trigger the other mentioned bug)


diff --git a/akregator/src/articlelistview.cpp b/akregator/src/articlelistview.cpp
index bf2219d..4df3427 100644
--- a/akregator/src/articlelistview.cpp
+++ b/akregator/src/articlelistview.cpp
@@ -162,6 +162,8 @@ void ArticleListView::setArticleModel( ArticleModel* model )
     proxy2->setSortRole( ArticleModel::SortRole );
     proxy2->setSourceModel( m_proxy );
 
+    connect(model, SIGNAL(rowsInserted(const QModelIndex&, int, int)), m_proxy, SLOT(invalidate()));
+
     FilterColumnsProxyModel* const columnsProxy = new FilterColumnsProxyModel( model );
     columnsProxy->setSortRole( ArticleModel::SortRole );
     columnsProxy->setSourceModel( proxy2 );

Could please someone apply that patch?
Comment 34 Christophe Giboudeaux 2012-01-08 12:49:50 UTC
(In reply to comment #33)
> after hours of try&error I have a patch working (which does not trigger the
> other mentioned bug)

looks correct. What's your real name to add it to the commit ?
Comment 35 Christophe Giboudeaux 2012-01-08 13:07:37 UTC
Git commit e1b2918611edc46cc21c6597ce46e4addc755ed6 by Christophe Giboudeaux, on behalf of Volker Härtel.
Committed on 08/01/2012 at 14:05.
Pushed by cgiboudeaux into branch 'master'.

Don't append new articles to the bottom of the list
MERGE: 4.8
FIXED-IN: 4.8

M  +3    -0    akregator/src/articlelistview.cpp

http://commits.kde.org/kdepim/e1b2918611edc46cc21c6597ce46e4addc755ed6
Comment 36 Christophe Giboudeaux 2012-01-08 13:08:18 UTC
Git commit 7fcf008cff1026deea8b6a4744ad550190845fd4 by Christophe Giboudeaux, on behalf of Volker Härtel.
Committed on 08/01/2012 at 14:05.
Pushed by cgiboudeaux into branch 'KDE/4.8'.

Don't append new articles to the bottom of the list
MERGE: 4.8
FIXED-IN: 4.8
(cherry picked from commit e1b2918611edc46cc21c6597ce46e4addc755ed6)

M  +3    -0    akregator/src/articlelistview.cpp

http://commits.kde.org/kdepim/7fcf008cff1026deea8b6a4744ad550190845fd4
Comment 37 Philip Murray 2014-03-16 20:22:25 UTC
Created attachment 85607 [details]
Screenshot

Encountering this bug in Akregator 4.8.4 still.
Comment 38 Bartosz Brachaczek 2014-03-16 20:46:27 UTC
(In reply to comment #37)
> Created attachment 85607 [details]
> Screenshot
> 
> Encountering this bug in Akregator 4.8.4 still.

Try Akregator 4.12.3 then and file a new bug report if it's still a problem there. Akregator 4.8.4 is 21 months old.